diff --git a/TAGS b/TAGS
index 40e1640..c22cb0d 100644
--- a/TAGS
+++ b/TAGS
@@ -1590,18 +3777,18 @@ pub struct PagePrev;PagePrev211,6589
 impl Cmd for PagePrev {PagePrev212,6610
     fn name(&self) -> &'static str {name213,6634
     fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute216,6697
-mod tests {tests247,7623
-    fn move_selection_down_produces_set_selected() {move_selection_down_produces_set_selected252,7712
-    fn move_selection_clamps_to_bounds() {move_selection_clamps_to_bounds267,8185
-    fn enter_advance_moves_down() {enter_advance_moves_down282,8652
-    fn law_move_to_start_idempotent() {law_move_to_start_idempotent300,9195
-    fn law_sequence_associativity() {law_sequence_associativity324,9998
-    fn law_move_to_end_reaches_last_col() {law_move_to_end_reaches_last_col372,11290
-    fn page_next_with_no_page_cats_returns_empty() {page_next_with_no_page_cats_returns_empty392,11983
-    fn page_prev_with_no_page_cats_returns_empty() {page_prev_with_no_page_cats_returns_empty402,12291
-    fn page_next_cycles_through_page_items() {page_next_cycles_through_page_items412,12599
-    fn page_prev_cycles_backward() {page_prev_cycles_backward427,13083
-pub(super) fn page_cat_data(ctx: &CmdContext) -> Vec<(String, Vec<String>, usize)> {page_cat_data443,13615
+pub(super) fn page_cat_data(ctx: &CmdContext) -> Vec<(String, Vec<String>, usize)> {page_cat_data247,7678
+mod tests {tests282,8775
+    fn move_selection_down_produces_set_selected() {move_selection_down_produces_set_selected287,8864
+    fn move_selection_clamps_to_bounds() {move_selection_clamps_to_bounds302,9337
+    fn enter_advance_moves_down() {enter_advance_moves_down317,9804
+    fn law_move_to_start_idempotent() {law_move_to_start_idempotent335,10347
+    fn law_sequence_associativity() {law_sequence_associativity359,11150
+    fn law_move_to_end_reaches_last_col() {law_move_to_end_reaches_last_col407,12442
+    fn page_next_with_no_page_cats_returns_empty() {page_next_with_no_page_cats_returns_empty427,13135
+    fn page_prev_with_no_page_cats_returns_empty() {page_prev_with_no_page_cats_returns_empty437,13443
+    fn page_next_cycles_through_page_items() {page_next_cycles_through_page_items447,13751
+    fn page_prev_cycles_backward() {page_prev_cycles_backward462,14235
 
 src/command/cmd/panel.rs,5404
 mod tests {tests7,126
@@ -1706,59 +3893,58 @@ impl Cmd for ExitSearchMode {ExitSearchMode195,6125
     fn name(&self) -> &'static str {name196,6155
     fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute199,6225
 
-src/command/cmd/mode.rs,3176
+src/command/cmd/mode.rs,3285
 mod tests {tests8,151
-    fn enter_edit_mode_produces_editing_mode() {enter_edit_mode_produces_editing_mode14,269
-    fn enter_tile_select_with_categories() {enter_tile_select_with_categories29,782
-    fn enter_tile_select_no_categories() {enter_tile_select_no_categories45,1279
-    fn enter_export_prompt_sets_mode() {enter_export_prompt_sets_mode56,1612
-    fn force_quit_always_produces_quit_mode() {force_quit_always_produces_quit_mode70,2046
-    fn save_and_quit_produces_save_then_quit() {save_and_quit_produces_save_then_quit83,2497
-    fn edit_or_drill_without_aggregation_enters_edit() {edit_or_drill_without_aggregation_enters_edit96,2984
-    fn enter_search_mode_sets_flag_and_clears_query() {enter_search_mode_sets_flag_and_clears_query107,3384
-pub struct EnterMode(pub AppMode);EnterMode129,4191
-impl Cmd for EnterMode {EnterMode130,4226
-    fn name(&self) -> &'static str {name131,4251
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute134,4315
-pub struct ForceQuit;ForceQuit149,4833
-impl Cmd for ForceQuit {ForceQuit150,4855
-    fn name(&self) -> &'static str {name151,4880
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute154,4944
-pub struct Quit;Quit161,5150
-impl Cmd for Quit {Quit162,5167
-    fn name(&self) -> &'static str {name163,5187
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute166,5242
-pub struct SaveAndQuit;SaveAndQuit179,5588
-impl Cmd for SaveAndQuit {SaveAndQuit180,5612
-    fn name(&self) -> &'static str {name181,5639
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute184,5695
-pub struct EnterEditMode {EnterEditMode193,6105
-    pub initial_value: String,initial_value194,6132
-impl Cmd for EnterEditMode {EnterEditMode196,6165
-    fn name(&self) -> &'static str {name197,6194
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute200,6263
-pub struct EditOrDrill;EditOrDrill215,6805
-impl Cmd for EditOrDrill {EditOrDrill216,6829
-    fn name(&self) -> &'static str {name217,6856
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute220,6923
-pub struct EnterEditAtCursorCmd;EnterEditAtCursorCmd253,8202
-impl Cmd for EnterEditAtCursorCmd {EnterEditAtCursorCmd254,8235
-    fn name(&self) -> &'static str {name255,8271
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute258,8345
-pub struct EnterExportPrompt;EnterExportPrompt265,8518
-impl Cmd for EnterExportPrompt {EnterExportPrompt266,8548
-    fn name(&self) -> &'static str {name267,8581
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute270,8654
-pub struct EnterSearchMode;EnterSearchMode277,8830
-impl Cmd for EnterSearchMode {EnterSearchMode278,8858
-    fn name(&self) -> &'static str {name279,8889
-    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute282,8949
-pub struct EnterTileSelect;EnterTileSelect292,9206
-impl Cmd for EnterTileSelect {EnterTileSelect293,9234
-    fn name(&self) -> &'static str {name294,9265
-    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute297,9336
+    fn enter_tile_select_with_categories() {enter_tile_select_with_categories14,269
+    fn enter_tile_select_no_categories() {enter_tile_select_no_categories30,766
+    fn enter_export_prompt_sets_mode() {enter_export_prompt_sets_mode41,1099
+    fn force_quit_always_produces_quit_mode() {force_quit_always_produces_quit_mode55,1533
+    fn save_and_quit_produces_save_then_quit() {save_and_quit_produces_save_then_quit68,1984
+    fn edit_or_drill_without_aggregation_enters_edit() {edit_or_drill_without_aggregation_enters_edit81,2471
+    fn edit_or_drill_passes_records_editing_mode_through() {edit_or_drill_passes_records_editing_mode_through101,3315
+    fn enter_edit_at_cursor_cmd_passes_target_mode_to_effect() {enter_edit_at_cursor_cmd_passes_target_mode_to_effect123,4188
+    fn edit_or_drill_pre_fills_edit_buffer_with_display_value() {edit_or_drill_pre_fills_edit_buffer_with_display_value143,4917
+    fn enter_search_mode_sets_flag_and_clears_query() {enter_search_mode_sets_flag_and_clears_query161,5545
+pub struct EnterMode(pub AppMode);EnterMode183,6352
+impl Cmd for EnterMode {EnterMode184,6387
+    fn name(&self) -> &'static str {name185,6412
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute188,6476
+pub struct ForceQuit;ForceQuit203,6994
+impl Cmd for ForceQuit {ForceQuit204,7016
+    fn name(&self) -> &'static str {name205,7041
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute208,7105
+pub struct Quit;Quit215,7311
+impl Cmd for Quit {Quit216,7328
+    fn name(&self) -> &'static str {name217,7348
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute220,7403
+pub struct SaveAndQuit;SaveAndQuit233,7749
+impl Cmd for SaveAndQuit {SaveAndQuit234,7773
+    fn name(&self) -> &'static str {name235,7800
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute238,7856
+pub struct EditOrDrill {EditOrDrill254,8698
+    pub edit_mode: AppMode,edit_mode255,8723
+impl Cmd for EditOrDrill {EditOrDrill257,8753
+    fn name(&self) -> &'static str {name258,8780
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute261,8847
+pub struct EnterEditAtCursorCmd {EnterEditAtCursorCmd295,10290
+    pub target_mode: AppMode,target_mode296,10324
+impl Cmd for EnterEditAtCursorCmd {EnterEditAtCursorCmd298,10356
+    fn name(&self) -> &'static str {name299,10392
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute302,10466
+pub struct EnterExportPrompt;EnterExportPrompt311,10702
+impl Cmd for EnterExportPrompt {EnterExportPrompt312,10732
+    fn name(&self) -> &'static str {name313,10765
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute316,10838
+pub struct EnterSearchMode;EnterSearchMode323,11014
+impl Cmd for EnterSearchMode {EnterSearchMode324,11042
+    fn name(&self) -> &'static str {name325,11073
+    fn execute(&self, _ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute328,11133
+pub struct EnterTileSelect;EnterTileSelect338,11390
+impl Cmd for EnterTileSelect {EnterTileSelect339,11418
+    fn name(&self) -> &'static str {name340,11449
+    fn execute(&self, ctx: &CmdContext) -> Vec<Box<dyn Effect>> {execute343,11520
 
-src/command/keymap.rs,5000
+src/command/keymap.rs,5093
 fn format_key_label(code: &KeyCode) -> String {format_key_label13,301
 pub enum KeyPattern {KeyPattern38,1303
     Key(KeyCode, KeyModifiers),Key40,1359
@@ -1779,67 +3965,69 @@ pub enum ModeKey {ModeKey49,1621
     CommandMode,CommandMode61,1808
     SearchMode,SearchMode62,1825
     ImportWizard,ImportWizard63,1841
-impl ModeKey {ModeKey66,1862
-    pub fn from_app_mode(mode: &AppMode, search_mode: bool) -> Option<Self> {from_app_mode67,1877
-pub enum Binding {Binding90,2989
-    Cmd {Cmd92,3088
-    Prefix(Arc<Keymap>),Prefix97,3203
-    Sequence(Vec<(&'static str, Vec<String>)>),Sequence99,3307
-pub struct Keymap {Keymap106,3589
-    bindings: HashMap<KeyPattern, Binding>,bindings107,3609
-    parent: Option<Arc<Keymap>>,parent108,3653
-impl fmt::Debug for Keymap {Keymap111,3689
-    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {fmt112,3718
-impl Keymap {Keymap119,3903
-    pub fn new() -> Self {new120,3917
-    pub fn with_parent(parent: Arc<Keymap>) -> Self {with_parent129,4182
-    pub fn bind(&mut self, key: KeyCode, mods: KeyModifiers, name: &'static str) {bind137,4388
-    pub fn bind_args(bind_args145,4661
-    pub fn bind_prefix(&mut self, key: KeyCode, mods: KeyModifiers, sub: Arc<Keymap>) {bind_prefix157,4977
-    pub fn bind_seq(bind_seq163,5231
-    pub fn bind_any_char(&mut self, name: &'static str, args: Vec<String>) {bind_any_char174,5525
-    pub fn bind_any(&mut self, name: &'static str) {bind_any180,5747
-    pub fn binding_hints(&self) -> Vec<(String, &'static str)> {binding_hints187,6068
-        let mut hints: Vec<(String, &'static str)> = selfstr188,6133
-    fn lookup_local(&self, key: KeyCode, mods: KeyModifiers) -> Option<&Binding> {lookup_local215,7143
-    pub fn lookup(&self, key: KeyCode, mods: KeyModifiers) -> Option<&Binding> {lookup237,8016
-    pub fn dispatch(dispatch243,8304
-pub struct SetTransientKeymap(pub Arc<Keymap>);SetTransientKeymap271,9254
-impl Effect for SetTransientKeymap {SetTransientKeymap273,9303
-    fn apply(&self, app: &mut crate::ui::app::App) {apply274,9340
-pub struct KeymapSet {KeymapSet280,9521
-    mode_maps: HashMap<ModeKey, Arc<Keymap>>,mode_maps281,9544
-    registry: CmdRegistry,registry282,9590
-impl KeymapSet {KeymapSet285,9620
-    pub fn new(registry: CmdRegistry) -> Self {new286,9637
-    pub fn registry(&self) -> &CmdRegistry {registry293,9778
-    pub fn insert(&mut self, mode: ModeKey, keymap: Arc<Keymap>) {insert297,9853
-    pub fn dispatch(dispatch302,10040
-    pub fn dispatch_transient(dispatch_transient314,10458
-    pub fn default_keymaps() -> Self {default_keymaps325,10764
-mod tests {tests908,32478
-    fn lookup_exact_match() {lookup_exact_match914,32669
-    fn lookup_exact_with_ctrl() {lookup_exact_with_ctrl922,32959
-    fn lookup_char_falls_back_to_none_mods() {lookup_char_falls_back_to_none_mods930,33257
-    fn lookup_non_char_does_not_fall_back_to_none_mods() {lookup_non_char_does_not_fall_back_to_none_mods940,33715
-    fn lookup_char_falls_to_any_char() {lookup_char_falls_to_any_char950,34128
-    fn lookup_non_char_skips_any_char() {lookup_non_char_skips_any_char964,34496
-    fn lookup_any_matches_everything() {lookup_any_matches_everything973,34804
-    fn lookup_exact_takes_priority_over_any_char() {lookup_exact_takes_priority_over_any_char987,35149
-    fn lookup_any_char_takes_priority_over_any() {lookup_any_char_takes_priority_over_any1002,35591
-    fn lookup_non_char_falls_to_any_not_any_char() {lookup_non_char_falls_to_any_not_any_char1017,36003
-    fn lookup_ctrl_char_with_only_none_binding_falls_through() {lookup_ctrl_char_with_only_none_binding_falls_through1032,36412
-    fn mode_key_normal_no_search() {mode_key_normal_no_search1043,36918
-    fn mode_key_normal_with_search_overrides() {mode_key_normal_with_search_overrides1049,37087
-    fn mode_key_help() {mode_key_help1055,37271
-    fn mode_key_quit_returns_none() {mode_key_quit_returns_none1061,37424
-    fn lookup_returns_prefix_binding() {lookup_returns_prefix_binding1069,37751
-    fn lookup_returns_sequence_binding() {lookup_returns_sequence_binding1078,38082
-    fn default_keymaps_has_all_modes() {default_keymaps_has_all_modes1092,38633
-    fn normal_mode_has_basic_movement() {normal_mode_has_basic_movement1120,39445
-    fn editing_mode_has_any_char_and_esc() {editing_mode_has_any_char_and_esc1144,40229
-    fn search_mode_has_any_char_and_esc() {search_mode_has_any_char_and_esc1158,40705
-    fn import_wizard_has_any_catchall() {import_wizard_has_any_catchall1170,41099
+    RecordsNormal,RecordsNormal64,1859
+    RecordsEditing,RecordsEditing65,1878
+impl ModeKey {ModeKey68,1901
+    pub fn from_app_mode(mode: &AppMode, search_mode: bool) -> Option<Self> {from_app_mode69,1916
+pub enum Binding {Binding94,3173
+    Cmd {Cmd96,3272
+    Prefix(Arc<Keymap>),Prefix101,3387
+    Sequence(Vec<(&'static str, Vec<String>)>),Sequence103,3491
+pub struct Keymap {Keymap110,3773
+    bindings: HashMap<KeyPattern, Binding>,bindings111,3793
+    parent: Option<Arc<Keymap>>,parent112,3837
+impl fmt::Debug for Keymap {Keymap115,3873
+    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {fmt116,3902
+impl Keymap {Keymap123,4087
+    pub fn new() -> Self {new124,4101
+    pub fn with_parent(parent: Arc<Keymap>) -> Self {with_parent133,4366
+    pub fn bind(&mut self, key: KeyCode, mods: KeyModifiers, name: &'static str) {bind141,4572
+    pub fn bind_args(bind_args149,4845
+    pub fn bind_prefix(&mut self, key: KeyCode, mods: KeyModifiers, sub: Arc<Keymap>) {bind_prefix161,5161
+    pub fn bind_seq(bind_seq167,5415
+    pub fn bind_any_char(&mut self, name: &'static str, args: Vec<String>) {bind_any_char178,5709
+    pub fn bind_any(&mut self, name: &'static str) {bind_any184,5931
+    pub fn binding_hints(&self) -> Vec<(String, &'static str)> {binding_hints191,6252
+        let mut hints: Vec<(String, &'static str)> = selfstr192,6317
+    fn lookup_local(&self, key: KeyCode, mods: KeyModifiers) -> Option<&Binding> {lookup_local219,7327
+    pub fn lookup(&self, key: KeyCode, mods: KeyModifiers) -> Option<&Binding> {lookup241,8200
+    pub fn dispatch(dispatch247,8488
+pub struct SetTransientKeymap(pub Arc<Keymap>);SetTransientKeymap275,9438
+impl Effect for SetTransientKeymap {SetTransientKeymap277,9487
+    fn apply(&self, app: &mut crate::ui::app::App) {apply278,9524
+pub struct KeymapSet {KeymapSet284,9705
+    mode_maps: HashMap<ModeKey, Arc<Keymap>>,mode_maps285,9728
+    registry: CmdRegistry,registry286,9774
+impl KeymapSet {KeymapSet289,9804
+    pub fn new(registry: CmdRegistry) -> Self {new290,9821
+    pub fn registry(&self) -> &CmdRegistry {registry297,9962
+    pub fn insert(&mut self, mode: ModeKey, keymap: Arc<Keymap>) {insert301,10037
+    pub fn dispatch(dispatch306,10224
+    pub fn dispatch_transient(dispatch_transient318,10642
+    pub fn default_keymaps() -> Self {default_keymaps329,10948
+mod tests {tests978,34976
+    fn lookup_exact_match() {lookup_exact_match984,35167
+    fn lookup_exact_with_ctrl() {lookup_exact_with_ctrl992,35457
+    fn lookup_char_falls_back_to_none_mods() {lookup_char_falls_back_to_none_mods1000,35755
+    fn lookup_non_char_does_not_fall_back_to_none_mods() {lookup_non_char_does_not_fall_back_to_none_mods1010,36213
+    fn lookup_char_falls_to_any_char() {lookup_char_falls_to_any_char1020,36626
+    fn lookup_non_char_skips_any_char() {lookup_non_char_skips_any_char1034,36994
+    fn lookup_any_matches_everything() {lookup_any_matches_everything1043,37302
+    fn lookup_exact_takes_priority_over_any_char() {lookup_exact_takes_priority_over_any_char1057,37647
+    fn lookup_any_char_takes_priority_over_any() {lookup_any_char_takes_priority_over_any1072,38089
+    fn lookup_non_char_falls_to_any_not_any_char() {lookup_non_char_falls_to_any_not_any_char1087,38501
+    fn lookup_ctrl_char_with_only_none_binding_falls_through() {lookup_ctrl_char_with_only_none_binding_falls_through1102,38910
+    fn mode_key_normal_no_search() {mode_key_normal_no_search1113,39416
+    fn mode_key_normal_with_search_overrides() {mode_key_normal_with_search_overrides1119,39585
+    fn mode_key_help() {mode_key_help1125,39769
+    fn mode_key_quit_returns_none() {mode_key_quit_returns_none1131,39922
+    fn lookup_returns_prefix_binding() {lookup_returns_prefix_binding1139,40249
+    fn lookup_returns_sequence_binding() {lookup_returns_sequence_binding1148,40580
+    fn default_keymaps_has_all_modes() {default_keymaps_has_all_modes1162,41131
+    fn normal_mode_has_basic_movement() {normal_mode_has_basic_movement1192,42016
+    fn editing_mode_has_any_char_and_esc() {editing_mode_has_any_char_and_esc1216,42800
+    fn search_mode_has_any_char_and_esc() {search_mode_has_any_char_and_esc1230,43276
+    fn import_wizard_has_any_catchall() {import_wizard_has_any_catchall1242,43670
 
 src/command/mod.rs,80
 pub mod cmd;cmd8,323
@@ -1950,81 +4138,81 @@ impl ImportPipeline {ImportPipeline28,984
     pub fn needs_path_selection(&self) -> bool {needs_path_selection60,1994
     pub fn preview_summary(&self) -> String {preview_summary64,2137
     pub fn build_model(&self) -> Result<Model> {build_model84,2916
-pub enum WizardStep {WizardStep245,9217
-    Preview,Preview246,9239
-    SelectArrayPath,SelectArrayPath247,9252
-    ReviewProposals,ReviewProposals248,9273
-    ConfigureDates,ConfigureDates249,9294
-    DefineFormulas,DefineFormulas250,9314
-    NameModel,NameModel251,9334
-    Done,Done252,9349
-pub struct ImportWizard {ImportWizard259,9615
-    pub pipeline: ImportPipeline,pipeline260,9641
-    pub step: WizardStep,step261,9675
-    pub cursor: usize,cursor263,9768
-    pub message: Option<String>,message265,9862
-    pub formula_editing: bool,formula_editing267,9945
-    pub formula_buffer: String,formula_buffer269,10020
-impl ImportWizard {ImportWizard272,10055
-    pub fn new(raw: Value) -> Self {new273,10075
-    pub fn advance(&mut self) {advance296,10803
-    fn has_time_categories(&self) -> bool {has_time_categories322,11788
-    pub fn time_category_proposals(&self) -> Vec<&FieldProposal> {time_category_proposals330,12072
-    pub fn confirm_path(&mut self) {confirm_path338,12334
-    pub fn move_cursor(&mut self, delta: i32) {move_cursor348,12789
-    pub fn toggle_proposal(&mut self) {toggle_proposal368,13562
-    pub fn cycle_proposal_kind(&mut self) {cycle_proposal_kind375,13800
-    pub fn push_name_char(&mut self, c: char) {push_name_char389,14467
-    pub fn pop_name_char(&mut self) {pop_name_char392,14563
-    fn date_config_item_count(&self) -> usize {date_config_item_count400,14982
-    pub fn date_config_at_cursor(&self) -> Option<(usize, DateComponent)> {date_config_at_cursor405,15160
-    fn time_category_indices(&self) -> Vec<usize> {time_category_indices421,15754
-    pub fn toggle_date_component(&mut self) {toggle_date_component434,16161
-    pub fn push_formula_char(&mut self, c: char) {push_formula_char452,16928
-    pub fn pop_formula_char(&mut self) {pop_formula_char460,17150
-    pub fn confirm_formula(&mut self) {confirm_formula465,17307
-    pub fn delete_formula(&mut self) {delete_formula476,17704
-    pub fn start_formula_edit(&mut self) {start_formula_edit486,18037
-    pub fn cancel_formula_edit(&mut self) {cancel_formula_edit492,18193
-    pub fn sample_formulas(&self) -> Vec<String> {sample_formulas498,18380
-    pub fn build_model(&self) -> Result<Model> {build_model522,19259
-mod tests {tests528,19366
-    fn flat_array_auto_selected() {flat_array_auto_selected534,19492
-    fn numeric_field_proposed_as_measure() {numeric_field_proposed_as_measure546,19895
-    fn low_cardinality_string_field_proposed_as_category() {low_cardinality_string_field_proposed_as_category554,20216
-    fn nested_json_needs_path_selection_when_multiple_arrays() {nested_json_needs_path_selection_when_multiple_arrays566,20660
-    fn single_nested_array_auto_selected() {single_nested_array_auto_selected576,20971
-    fn select_path_populates_records_and_proposals() {select_path_populates_records_and_proposals589,21343
-    fn build_model_fails_with_no_accepted_categories() {build_model_fails_with_no_accepted_categories601,21697
-    fn build_model_creates_categories_and_measure_category() {build_model_creates_categories_and_measure_category611,22007
-    fn label_fields_imported_as_label_category_coords() {label_fields_imported_as_label_category_coords623,22423
-    fn label_category_defaults_to_none_axis() {label_category_defaults_to_none_axis650,23728
-    fn build_model_cells_match_source_data() {build_model_cells_match_source_data663,24216
-    fn model_name_defaults_to_imported_model() {model_name_defaults_to_imported_model690,25121
-    fn build_model_adds_formulas_from_pipeline() {build_model_adds_formulas_from_pipeline697,25322
-    fn build_model_extracts_date_month_component() {build_model_extracts_date_month_component716,26090
-    fn sample_wizard() -> ImportWizard {sample_wizard745,27317
-    fn wizard_starts_at_review_proposals_for_flat_array() {wizard_starts_at_review_proposals_for_flat_array754,27616
-    fn wizard_starts_at_select_array_path_for_multi_path_object() {wizard_starts_at_select_array_path_for_multi_path_object760,27785
-    fn wizard_advance_from_review_proposals_skips_dates_when_none() {wizard_advance_from_review_proposals_skips_dates_when_none770,28085
-    fn wizard_advance_full_sequence() {wizard_advance_full_sequence779,28418
-    fn wizard_move_cursor_clamps() {wizard_move_cursor_clamps794,28893
-    fn wizard_toggle_proposal() {wizard_toggle_proposal809,29326
-    fn wizard_cycle_proposal_kind() {wizard_cycle_proposal_kind819,29671
-    fn wizard_model_name_editing() {wizard_model_name_editing832,30132
-    fn wizard_confirm_path() {wizard_confirm_path843,30450
-    fn wizard_formula_lifecycle() {wizard_formula_lifecycle859,31111
-    fn wizard_delete_formula() {wizard_delete_formula897,32271
-    fn wizard_delete_formula_at_zero() {wizard_delete_formula_at_zero909,32685
-    fn wizard_confirm_empty_formula_is_noop() {wizard_confirm_empty_formula_is_noop919,32973
-    fn sample_formulas_with_two_measures() {sample_formulas_with_two_measures929,33382
-    fn sample_formulas_with_one_measure() {sample_formulas_with_one_measure939,33740
-    fn sample_formulas_with_no_measures() {sample_formulas_with_no_measures951,34148
-    fn preview_summary_for_array() {preview_summary_for_array963,34601
-    fn preview_summary_for_object() {preview_summary_for_object974,34905
-    fn wizard_date_config_toggle() {wizard_date_config_toggle988,35410
-    fn wizard_date_config_at_cursor_mapping() {wizard_date_config_at_cursor_mapping1024,36707
-    fn build_model_record_with_missing_category_value_skipped() {build_model_record_with_missing_category_value_skipped1048,37695
-    fn build_model_with_integer_category_values() {build_model_with_integer_category_values1066,38390
-    fn build_model_formulas_without_measure_category() {build_model_formulas_without_measure_category1084,39191
-    fn build_model_date_components_appear_in_cell_keys() {build_model_date_components_appear_in_cell_keys1102,40030
+pub enum WizardStep {WizardStep247,9217
+    Preview,Preview248,9239
+    SelectArrayPath,SelectArrayPath249,9252
+    ReviewProposals,ReviewProposals250,9273
+    ConfigureDates,ConfigureDates251,9294
+    DefineFormulas,DefineFormulas252,9314
+    NameModel,NameModel253,9334
+    Done,Done254,9349
+pub struct ImportWizard {ImportWizard261,9615
+    pub pipeline: ImportPipeline,pipeline262,9641
+    pub step: WizardStep,step263,9675
+    pub cursor: usize,cursor265,9768
+    pub message: Option<String>,message267,9862
+    pub formula_editing: bool,formula_editing269,9945
+    pub formula_buffer: String,formula_buffer271,10020
+impl ImportWizard {ImportWizard274,10055
+    pub fn new(raw: Value) -> Self {new275,10075
+    pub fn advance(&mut self) {advance298,10803
+    fn has_time_categories(&self) -> bool {has_time_categories324,11788
+    pub fn time_category_proposals(&self) -> Vec<&FieldProposal> {time_category_proposals332,12072
+    pub fn confirm_path(&mut self) {confirm_path340,12334
+    pub fn move_cursor(&mut self, delta: i32) {move_cursor350,12789
+    pub fn toggle_proposal(&mut self) {toggle_proposal370,13562
+    pub fn cycle_proposal_kind(&mut self) {cycle_proposal_kind377,13800
+    pub fn push_name_char(&mut self, c: char) {push_name_char391,14467
+    pub fn pop_name_char(&mut self) {pop_name_char394,14563
+    fn date_config_item_count(&self) -> usize {date_config_item_count402,14982
+    pub fn date_config_at_cursor(&self) -> Option<(usize, DateComponent)> {date_config_at_cursor407,15160
+    fn time_category_indices(&self) -> Vec<usize> {time_category_indices423,15754
+    pub fn toggle_date_component(&mut self) {toggle_date_component436,16161
+    pub fn push_formula_char(&mut self, c: char) {push_formula_char454,16928
+    pub fn pop_formula_char(&mut self) {pop_formula_char462,17150
+    pub fn confirm_formula(&mut self) {confirm_formula467,17307
+    pub fn delete_formula(&mut self) {delete_formula478,17704
+    pub fn start_formula_edit(&mut self) {start_formula_edit488,18037
+    pub fn cancel_formula_edit(&mut self) {cancel_formula_edit494,18193
+    pub fn sample_formulas(&self) -> Vec<String> {sample_formulas500,18380
+    pub fn build_model(&self) -> Result<Model> {build_model524,19259
+mod tests {tests530,19366
+    fn flat_array_auto_selected() {flat_array_auto_selected536,19492
+    fn numeric_field_proposed_as_measure() {numeric_field_proposed_as_measure548,19895
+    fn low_cardinality_string_field_proposed_as_category() {low_cardinality_string_field_proposed_as_category556,20216
+    fn nested_json_needs_path_selection_when_multiple_arrays() {nested_json_needs_path_selection_when_multiple_arrays568,20660
+    fn single_nested_array_auto_selected() {single_nested_array_auto_selected578,20971
+    fn select_path_populates_records_and_proposals() {select_path_populates_records_and_proposals591,21343
+    fn build_model_fails_with_no_accepted_categories() {build_model_fails_with_no_accepted_categories603,21697
+    fn build_model_creates_categories_and_measure_category() {build_model_creates_categories_and_measure_category613,22007
+    fn label_fields_imported_as_label_category_coords() {label_fields_imported_as_label_category_coords625,22423
+    fn label_category_defaults_to_none_axis() {label_category_defaults_to_none_axis652,23728
+    fn build_model_cells_match_source_data() {build_model_cells_match_source_data665,24216
+    fn model_name_defaults_to_imported_model() {model_name_defaults_to_imported_model692,25121
+    fn build_model_adds_formulas_from_pipeline() {build_model_adds_formulas_from_pipeline699,25322
+    fn build_model_extracts_date_month_component() {build_model_extracts_date_month_component718,26090
+    fn sample_wizard() -> ImportWizard {sample_wizard747,27317
+    fn wizard_starts_at_review_proposals_for_flat_array() {wizard_starts_at_review_proposals_for_flat_array756,27616
+    fn wizard_starts_at_select_array_path_for_multi_path_object() {wizard_starts_at_select_array_path_for_multi_path_object762,27785
+    fn wizard_advance_from_review_proposals_skips_dates_when_none() {wizard_advance_from_review_proposals_skips_dates_when_none772,28085
+    fn wizard_advance_full_sequence() {wizard_advance_full_sequence781,28418
+    fn wizard_move_cursor_clamps() {wizard_move_cursor_clamps796,28893
+    fn wizard_toggle_proposal() {wizard_toggle_proposal811,29326
+    fn wizard_cycle_proposal_kind() {wizard_cycle_proposal_kind821,29671
+    fn wizard_model_name_editing() {wizard_model_name_editing834,30132
+    fn wizard_confirm_path() {wizard_confirm_path845,30450
+    fn wizard_formula_lifecycle() {wizard_formula_lifecycle861,31111
+    fn wizard_delete_formula() {wizard_delete_formula899,32271
+    fn wizard_delete_formula_at_zero() {wizard_delete_formula_at_zero911,32685
+    fn wizard_confirm_empty_formula_is_noop() {wizard_confirm_empty_formula_is_noop921,32973
+    fn sample_formulas_with_two_measures() {sample_formulas_with_two_measures931,33382
+    fn sample_formulas_with_one_measure() {sample_formulas_with_one_measure941,33740
+    fn sample_formulas_with_no_measures() {sample_formulas_with_no_measures953,34148
+    fn preview_summary_for_array() {preview_summary_for_array965,34601
+    fn preview_summary_for_object() {preview_summary_for_object976,34905
+    fn wizard_date_config_toggle() {wizard_date_config_toggle990,35410
+    fn wizard_date_config_at_cursor_mapping() {wizard_date_config_at_cursor_mapping1018,36495
+    fn build_model_record_with_missing_category_value_skipped() {build_model_record_with_missing_category_value_skipped1042,37483
+    fn build_model_with_integer_category_values() {build_model_with_integer_category_values1060,38178
+    fn build_model_formulas_without_measure_category() {build_model_formulas_without_measure_category1078,38979
+    fn build_model_date_components_appear_in_cell_keys() {build_model_date_components_appear_in_cell_keys1096,39818
